\section{Evaluation}
\label{sec_evaluation}
\subsection{MemOpLight with two containers}
\label{subsec_evaluation_two_containers}
MemOpLight is designed to consolidate memory while ensuring memory performance isolation.
To verify this, we run again the experiment from Section \ref{subsec_problem_soft}, this time enabling MemOpLight.
We plot the results in Figure \ref{fig_mechanism}.

\step{1}, \step{3} and \step{5} in Figure \ref{fig_transactions_mechanism} follow the same pattern than the same phases in Figure \ref{fig_transactions_soft}.
Figure \ref{fig_memory_mechanism} shows that, like Figure \ref{fig_memory_soft}, when both containers receive high or intermediate load, their memory footprints follow their \texttt{soft} limits (\step{1}, \step{3} and \step{5}).
A has then a larger footprint than B, this shows that MemOpLight ensures memory performance isolation.

When A alone is offered a high load, its memory footprint increases (\step{2}).
Like \step{6} in Figure \ref{fig_memory_soft}, when A stops completely, there is no more memory pressure, B's footprint grows and permits it to increase its performance to the maximum throughput.

Note in Figure \ref{fig_transactions_mechanism} \step{2} that, when A has high load and B low load, MemOpLight lets A's throughput equals its SLO.
We conclude that MemOpLight ensures consolidation.

Moreover, when both containers are active, their throughputs are better than the previous results (\step{1}, \step{3} and \step{5}).
Globally, A has better performance than B.

\begin{table*}
	\centering

	\begin{tabular}{l|c|c|c|c|c|c|c|c|c|c|c}
		\hline
		\diagbox{Transactions}{Phases} & \multicolumn{2}{c|}{\step{1}} & \multicolumn{2}{c|}{\step{2}} & \multicolumn{2}{c|}{\step{3}} & \multicolumn{2}{c|}{\step{4}} & \multicolumn{2}{c|}{\step{5}} & \step{6}\\
		\hline
		Container & A & B & A & B & A & B & A & B & A & B & B\\
		\hline
		Throughput & 2000 & 2000 & 2000 & 200 & 2000 & 1500 & 200 & 200 & 1500 & 2000 & 2000\\
		\hline
		Limits not set (Section \ref{subsec_problem_without}) & 1053 & \textbf{1043} & 1374 & 196 & 1054 & \textbf{1168} & 195 & 197 & 1195 & \textbf{1145} & \textbf{1751}\\
		\texttt{Max} limit (Section \ref{subsec_problem_max}) & 1290 & 894 & 1411 & 196 & 1314 & 968 & 196 & 660 & 1358 & 978 & 962\\
		\texttt{Soft} limit (Section \ref{subsec_problem_soft}) & 1268 & 879 & 1423 & 197 & 1299 & 969 & 196 & 794 & 1360 & 970 & 974\\
		MemOpLight (Section \ref{subsec_evaluation_two_containers}) & \textbf{1351} & 933 & \textbf{1670} & 195 & \textbf{1362} & 999 & 196 & 197 & \textbf{1370} & 1036 & 1723\\
	\end{tabular}

	\caption{Measured throughput in each phase of each experiment (in t/s rounded to nearest integer)}
	\label{table_sumup}
\end{table*}

Table \ref{table_sumup} summarizes all the previous measurements.
B has lower performance with MemOpLight and would have better performance with no limits set.
This behavior is normal, since in the latter case there is no memory performance isolation.
Nonetheless, this is not expected in IaaS since a client could have paid more than another so one client would be privileged over the other.

In summary, MemOpLight increases performance of containers by redistributing memory following their needs.

\subsection{MemOpLight with eight containers}
To confirm the above results, we create a more realistic scenario with 8 containers.
Along the phases, containers receive high, intermediate or low load.

\begin{table*}
	\centering

	\begin{tabular}{l|c||c||c|c|c|c|c|c|c|c|c}
		\hline
		Containers & SLO (t/s) & Limit (if set) & \step{1} & \step{2} & \step{3} & \step{4} & \step{5} & \step{6} & \step{7} & \step{8} & \step{9}\\
		\hline
		A & 1800 & \SI{1400}{\mega\byte} & \cellcolor{black} \textcolor{white}{2500} & \cellcolor{blue_grey_200} 1710 & \cellcolor{black} \textcolor{white}{2500} & 200 & \cellcolor{blue_grey} 1890 & 200 & 200 & 200 & \cellcolor{black} \textcolor{white}{2500}\\
		B & 1600 & \SI{1000}{\mega\byte} & \cellcolor{blue_grey_200} 1520 & \cellcolor{black} \textcolor{white}{2500} & \cellcolor{black} \textcolor{white}{2500} & 200 & \cellcolor{black} \textcolor{white}{2500} & 200 & \cellcolor{blue_grey_200} 1520 & \cellcolor{black} \textcolor{white}{2500} & 200\\
		C & 1400 & \SI{800}{\mega\byte} & \cellcolor{blue_grey_200} 1330 & \cellcolor{blue_grey} 1470 & 200 & \cellcolor{blue_grey} 1470 & \cellcolor{black} \textcolor{white}{2500} & \cellcolor{blue_grey_200} 1330 & \cellcolor{blue_grey} 1470 & 200 & \cellcolor{blue_grey} 1470\\
		D & 1400 & \SI{800}{\mega\byte} & \cellcolor{black} \textcolor{white}{2500} & \cellcolor{blue_grey} 1470 & 200 & 200 & 200 & \cellcolor{blue_grey} 1470 & 200 & \cellcolor{black} \textcolor{white}{2500} & \cellcolor{black} \textcolor{white}{2500}\\
		E & 1200 & \SI{600}{\mega\byte} & \cellcolor{blue_grey_200} 1140 & \cellcolor{blue_grey_200} 1140 & 200 & \cellcolor{black} \textcolor{white}{2500} & \cellcolor{blue_grey} 1260 & \cellcolor{black} \textcolor{white}{2500} & \cellcolor{black} \textcolor{white}{2500} & \cellcolor{black} \textcolor{white}{2500} & 200\\
		F & 1200 & \SI{600}{\mega\byte} & \cellcolor{black} \textcolor{white}{2500} & \cellcolor{blue_grey} 1260 & 200 & \cellcolor{black} \textcolor{white}{2500} & 200 & \cellcolor{black} \textcolor{white}{2500} & \cellcolor{blue_grey} 1260 & \cellcolor{blue_grey} 1260 & \cellcolor{black} \textcolor{white}{2500}\\
		G & 1000 & \SI{400}{\mega\byte} & \cellcolor{black} \textcolor{white}{2500} & 200 & \cellcolor{black} \textcolor{white}{2500} & 200 & 200 & 200 & 200 & \cellcolor{blue_grey_200} 950 & \cellcolor{blue_grey_200} 950\\
		H & 800 & \SI{400}{\mega\byte} & \cellcolor{blue_grey} 840 & \cellcolor{black} \textcolor{white}{2500} & 200 & 200 & \cellcolor{blue_grey_200} 760 & 200 & \cellcolor{blue_grey_200} 760 & \cellcolor{blue_grey_200} 760 & \cellcolor{black} \textcolor{white}{2500}\\
	\end{tabular}

	\caption{Throughput in each phase of experiment (in transactions per second)}
	\label{table_load}
\end{table*}

The scenario and its characteristics are described in Table \ref{table_load}.
The first column is SLO.
The second one shows the values for \texttt{max} and \texttt{soft} limits.
The other columns describe the load at each phase of the experiment.
Throughput can have multiple values:
\begin{itemize}
	\item High: The container receives 2500 t/s.
	Black cells, in Table \ref{table_load}, depicts phases where containers receive high load.
	\item Intermediate : The container receives its SLO $\pm 5\%$ t/s.
	In Table \ref{table_load}, gray and light gray cells, shows phases with intermediate load.
	\item Low: The container sustains only 200 t/s.
\end{itemize}
A phase lasts for 120 seconds so the whole scenario lasts for 1080 seconds.

In this experiment, we focus on the respect of SLO and the global performance.
Figure \ref{fig_eight_default} to Figure \ref{fig_eight_mechanism} plot the average throughput generated across 10 runs.
Hatched colors emphasize throughputs that are above SLO.

\begin{figure}
	\centering

	\includegraphics[scale = .50]{default_stacked_transactions.pdf}
	\caption{Eight containers with limits not set}
	\label{fig_eight_default}

	\includegraphics[scale = .50]{max_stacked_transactions.pdf}
	\caption{Eight containers setting \texttt{max} limits}
	\label{fig_eight_max}

	\includegraphics[scale = .50]{soft_stacked_transactions.pdf}
	\caption{Eight containers setting \texttt{soft} limits}
	\label{fig_eight_soft}

	\includegraphics[scale = .50]{mechanism_stacked_transactions.pdf}
	\caption{Eight containers with MemOpLight and setting \texttt{soft} limits}
	\label{fig_eight_mechanism}
\end{figure}

With limits not sets, in Figure \ref{fig_eight_default}, \step{1} shows that containers have approximately the same throughput.
So, there is no memory performance isolation (same problem as Figure \ref{fig_default}).
In \step{3}, A, B and G increase their performance slightly because the other receive low load, thus memory consolidation occurs (like \step{2} in Figure \ref{fig_default}).

With \texttt{max} limits set as indicated in Table \ref{table_load}, in Figure \ref{fig_eight_max}, in \step{1} containers performance vary according to their respective \texttt{max} limit.
In \step{3}, performance of A and B grows, but not container G because of its low \texttt{max} limit.
Comparing Figure \ref{fig_eight_max} to Figure \ref{fig_eight_default}, containers less exceed their SLO because of the \texttt{max} limit.

Figure \ref{fig_eight_soft} is quite similar to Figure \ref{fig_eight_max}.
Indeed, since there is memory pressure during the whole experiment the \texttt{soft} limit activates so containers with high values of \texttt{soft} limits have better performance compared to containers with lower values.

Figure \ref{fig_eight_mechanism} plots the results with MemOpLight.
\step{1} in Figure \ref{fig_eight_mechanism} is similar to the same phase in Figure \ref{fig_eight_soft}.
Indeed, in this phase MemOpLight cannot reclaim memory efficiently and degrades to the \texttt{soft} limit mechanism.
In \step{3}, container A performs better than with other mechanisms because it exceeds its SLO.
Figure \ref{fig_eight_mechanism} shows that, with MemOpLight, containers exceed their SLO more often, which shows that MemOpLight consolidates memory, giving them better performance.

Table \ref{table_sumup_eight} summarizes throughput for each container with all the tested mechanisms.
One can see that MemOpLight supports better performance for five of the eight containers.
Where MemOpLight performs worse, the difference is only about 0.6\%, 2.3\% and 1.9\% for container B, G and H compared to the experiment with limits not set.
Overall, MemOpLight reaches 122.6 million transactions which is 8.9\% better than with limits not set.

\begin{table*}
	\centering

	\begin{tabular}{l|cccccccc|c}
		\hline
		\diagbox{Mechanism}{Containers} & A & B & C & D & E & F & G & H & Total\\
		\hline
		No limits set & 15.2 & 14.5 & 17.3 & 11.9 & 18.7 & 15.9 & \textbf{8.8} & \textbf{10.3} & 112.6\\
		\texttt{Max} limit & 13.6 & 13.8 & 13.8 & 8.5 & 14.9 & 9.9 & 4.6 & 6.8 & 85.9\\
		\texttt{Soft} limit & 17.1 & \textbf{17.4} & 17.6 & 12.6 & 17.5 & 13.4 & 7.3 & 9.5 & 112.4\\
		MemOpLight & \textbf{17.5} & 17.3 & \textbf{18.4} & \textbf{13.7} & \textbf{20.2} & \textbf{16.8} & 8.6 & 10.1 & \textbf{122.6}\\
	\end{tabular}

	\caption{Total containers' throughputs (in million of t/s with different mechanisms, averaged over 10 runs)}
	\label{table_sumup_eight}
\end{table*}

Figure \ref{fig_eight_color_default} to Figure \ref{fig_eight_color_mechanism} plot the colors of containers over time during the sixth run of our experiment.
Globally, it seems that containers are seldom yellow.
In particular, Figure \ref{fig_eight_color_mechanism} shows that MemOpLight improves of, at least, 15\% the time where containers are green compared to other mechanisms.
Indeed, \step{3} to \step{9} are greener with MemOpLight.
Specially with MemOpLight, in \step{3}, \step{4} and \step{5} there are moments where all containers are green which never happens in the other figures.
Figures \ref{fig_eight_color_soft} and \ref{fig_eight_color_mechanism} show a similar pattern for \step{1} and \step{2}.
Because all containers are offered high or intermediate throughput, MemOpLight cannot satisfy containers and degrades to the \texttt{soft} limit.

\begin{figure}
	\centering

	\includegraphics[scale = .5]{default_color.pdf}
	\caption{Containers' colors, with limits not set}
	\label{fig_eight_color_default}

	\includegraphics[scale = .5]{max_limit_color.pdf}
	\caption{Containers' colors, setting \texttt{max} limits}
	\label{fig_eight_color_max}

	\includegraphics[scale = .5]{soft_limit_color.pdf}
	\caption{Containers' colors, setting \texttt{soft} limits}
	\label{fig_eight_color_soft}

	\includegraphics[scale = .5]{mechanism_color.pdf}
	\caption{Containers' colors, with MemOpLight and setting \texttt{soft} limits}
	\label{fig_eight_color_mechanism}
\end{figure}

Table \ref{table_sumup_eight_percent} summarizes these results, it shows fraction of time where containers are satisfied.
This time is the sum of yellow and green time.
MemOpLight maximizes the number of satisfied containers.
It also increases the time passed satisfied throughout the whole experiment from 44\% to 57\%.
Thus, MemOpLight enhances efficiency, since it improves performance with the same hardware.

\begin{table*}
	\centering

	\begin{tabular}{l|cccccccc|c}
		\hline
		\diagbox{Mechanism}{Containers} & A & B & C & D & E & F & G & H & Total\\
		\hline
		No limits set & 42 & 23 & 8 & 35 & 69 & 39 & 62 & \textbf{71} & 44\\
		\texttt{Max} limit & \textbf{60} & 35 & 5 & 37 & 73 & 15 & 53 & 35 & 39\\
		\texttt{Soft} limit & 56 & 42 & 11 & 35 & 64 & 16 & 53 & 32 & 39\\
		MemOpLight & 58 & \textbf{44} & \textbf{42} & \textbf{52} & \textbf{76} & \textbf{53} & \textbf{67} & 67 & \textbf{57}\\
	\end{tabular}

	\caption{Fraction of time (in percent) where container is satisfied (\textit{i.e.} yellow or green) according to mechanisms (averaged over 10 runs)}
	\label{table_sumup_eight_percent}
\end{table*}

In summary, MemOpLight improves throughput and enables containers to be satisfied more often.